package org.example;

import java.nio.charset.StandardCharsets;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import org.apache.commons.codec.digest.DigestUtils;
import com.google.common.hash.Hashing;

public class Main {
    public static void main(String[] args) {
        String input = "Hello, world!";

        try {
            MessageDigest digest = MessageDigest.getInstance("SHA-1");
            byte[] encodedHash = digest.digest(input.getBytes(StandardCharsets.UTF_8));

            StringBuilder hexString = new StringBuilder();
            for (byte b : encodedHash) {
                String hex = Integer.toHexString(0xff & b);
                if (hex.length() == 1) hexString.append('0');
                hexString.append(hex);
            }

            String hexDigest = hexString.toString();
            System.out.println("SHA-1 digest (MessageDigest): " + hexDigest);
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        }

        String hexDigest = DigestUtils.sha1Hex(input);
        System.out.println("SHA-1 digest (Apache Commons Codec): " + hexDigest);

        String hexDigest2 = Hashing.sha1().hashString(input, StandardCharsets.UTF_8).toString();
        System.out.println("SHA-1 digest (Google Guava): " + hexDigest2);

    }
}